/*
 * Real-Time Workshop code generation for Simulink model "fadingchannelconstructed.mdl".
 *
 * Model Version                        : 1.39
 * Real-Time Workshop file version      : 5.0 $Date: 2002/05/30 19:21:33 $
 * Real-Time Workshop file generated on : Wed Mar 17 14:58:13 2004
 * TLC version                          : 5.0 (Jun 18 2002)
 * C source code generated on           : Wed Mar 17 14:58:13 2004
 */

#include <math.h>
#include <string.h>
#include "fadingchannelconstructed.h"
#include "fadingchannelconstructed_private.h"

/* Block signals (auto storage) */
BlockIO rtB;

/* Block states (auto storage) */
D_Work rtDWork;

/* Parent Simstruct */
static rtModel_fadingchannelconstructed model_S;
rtModel_fadingchannelconstructed *const rtM_fadingchannelconstructed = &model_S;

/* Initial conditions for root system: '<Root>' */
void MdlInitialize(void)
{

  /* DSP Blockset Delay (sdspdly2) - '<S1>/Integer Delay' */
  rtDWork.Integer_Delay_BUFF_OFFSET = 49;
  MWDSP_DelayCopyScalarICs( (byte_T *)&rtDWork.Integer_Delay_BUFF[0], (byte_T
    *)&rtP.Integer_Delay_IC, 1*51, sizeof(real_T) );

  /* DSP Blockset Filter Implementation (sdspfilter) - '<S5>/Direct-Form II Transpose Filter' */
  {
    real_T *statePtr = (real_T *) &rtDWork.Direct_Form_II_Tran_FILT_STATES[0];
    /* Scalar expansion of ICs with extra zero element per channel */
    int_T numElems = 100;
    while (numElems--) {
      *statePtr++ = *(const real_T *)&rtP.Direct_Form_II_Tran_ICRTP;
    }
    *statePtr = 0.0;
  }
}

/* Start for root system: '<Root>' */
void MdlStart(void)
{

  /* RandomNumber Block: <S2>/Random Number */
  {
    uint_T *RandSeed = (uint_T *) &rtDWork.Random_Number_a_IWORK.RandSeed;
    int_T r, t;
    *RandSeed = 41U;
    r = *RandSeed >> 16;
    t = *RandSeed & BIT16;
    *RandSeed = ((*RandSeed - (r << 16) - t) << 16) + t + r;
    if (*RandSeed < 1) {
      *RandSeed = SEED0;
    }
    if (*RandSeed > MAXSEED) {
      *RandSeed = MAXSEED;
    }

    rtDWork.Random_Number_a_RWORK.NextOutput =
      rt_NormalRand(RandSeed++) * rtP.Random_Number_a_StdDev +
      rtP.Random_Number_a_Mean;
  }

  /* DiscretePulseGenerator Block: <Root>/Pulse Generator */
  {
    int_T Ns;
    real_T tFirst = rtmGetTStart(rtM_fadingchannelconstructed);
    Ns = (int_T)floor(tFirst / 0.0002 + 0.5);
    if (Ns <= 0) {
      rtDWork.Pulse_Generator_IWORK.ClockTicksCounter = Ns;
    } else {
      rtDWork.Pulse_Generator_IWORK.ClockTicksCounter = Ns -
        (int_T)(rtP.Pulse_Generator_Period*floor((real_T)Ns /
        rtP.Pulse_Generator_Period));
    }
  }

  /* RandomNumber Block: <S3>/Random Number */
  {
    uint_T *RandSeed = (uint_T *) &rtDWork.Random_Number_b_IWORK.RandSeed;
    int_T r, t;
    *RandSeed = 41U;
    r = *RandSeed >> 16;
    t = *RandSeed & BIT16;
    *RandSeed = ((*RandSeed - (r << 16) - t) << 16) + t + r;
    if (*RandSeed < 1) {
      *RandSeed = SEED0;
    }
    if (*RandSeed > MAXSEED) {
      *RandSeed = MAXSEED;
    }

    rtDWork.Random_Number_b_RWORK.NextOutput =
      rt_NormalRand(RandSeed++) * rtP.Random_Number_b_StdDev +
      rtP.Random_Number_b_Mean;
  }

  /* ToWorkspace Block: <Root>/To Workspace */
  {
    static const int_T rt_ToWksWidths[] = {1};
    static const int_T rt_ToWksNumDimensions[] = {1};
    static const int_T rt_ToWksDimensions[] = {1};
    static const BuiltInDTypeId rt_ToWksDataTypeIds[] = {SS_DOUBLE};
    static const int_T rt_ToWksComplexSignals[] = {0};
    static const int_T rt_ToWksFrameData[] = {0};
    static const char_T rt_ToWksLabels[] = "";
    static const RTWLogSignalInfo rt_ToWksSignalInfo = {
      1,
      rt_ToWksWidths,
      rt_ToWksNumDimensions,
      rt_ToWksDimensions,
      rt_ToWksDataTypeIds,
      rt_ToWksComplexSignals,
      rt_ToWksFrameData,
      rt_ToWksLabels,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
    };
    static const char_T rt_ToWksBlockName[] =
      "fadingchannelconstructed/To Workspace";

    rtDWork.To_Workspace_PWORK.LoggedData =
      rt_CreateStructLogVar(rtM_fadingchannelconstructed->rtwLogInfo,
      rtM_fadingchannelconstructed->Timing.tFinal,
      rtM_fadingchannelconstructed->Timing.stepSize,
      &(rtmGetErrorStatus(rtM_fadingchannelconstructed)), "RayleighPDFOutput",
      0, 0, 1, 0.0002, &rt_ToWksSignalInfo, rt_ToWksBlockName);

    if (rtDWork.To_Workspace_PWORK.LoggedData == NULL) return;
  }

  /* ToWorkspace Block: <Root>/To Workspace1 */
  {
    static const int_T rt_ToWksWidths[] = {1};
    static const int_T rt_ToWksNumDimensions[] = {1};
    static const int_T rt_ToWksDimensions[] = {1};
    static const BuiltInDTypeId rt_ToWksDataTypeIds[] = {SS_DOUBLE};
    static const int_T rt_ToWksComplexSignals[] = {0};
    static const int_T rt_ToWksFrameData[] = {0};
    static const char_T rt_ToWksLabels[] = "";
    static const RTWLogSignalInfo rt_ToWksSignalInfo = {
      1,
      rt_ToWksWidths,
      rt_ToWksNumDimensions,
      rt_ToWksDimensions,
      rt_ToWksDataTypeIds,
      rt_ToWksComplexSignals,
      rt_ToWksFrameData,
      rt_ToWksLabels,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
    };
    static const char_T rt_ToWksBlockName[] =
      "fadingchannelconstructed/To Workspace1";

    rtDWork.To_Workspace1_PWORK.LoggedData =
      rt_CreateStructLogVar(rtM_fadingchannelconstructed->rtwLogInfo,
      rtM_fadingchannelconstructed->Timing.tFinal,
      rtM_fadingchannelconstructed->Timing.stepSize,
      &(rtmGetErrorStatus(rtM_fadingchannelconstructed)), "AWGN", 0, 0, 1,
      0.0002, &rt_ToWksSignalInfo, rt_ToWksBlockName);

    if (rtDWork.To_Workspace1_PWORK.LoggedData == NULL) return;
  }

  MdlInitialize();
}

/* Outputs for root system: '<Root>' */
void MdlOutputs(int_T tid)
{
  /* local block i/o variables */
  creal_T rtb_Join;
  real_T rtb_Reshape_a;
  real_T rtb_Complex_to_Real_Imag_o1;
  real_T rtb_Complex_to_Real_Imag_o2;
  real_T rtb_Reshape_b;
  real_T rtb_temp15;

  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);

  /* RandomNumber: '<S2>/Random Number' */
  rtB.Random_Number_a = rtDWork.Random_Number_a_RWORK.NextOutput;

  /* DiscreteStateSpace: '<S7>/Discrete State-Space' */
  {
    rtb_temp15 = rtP.Discrete_State_Space_a_D*rtB.Random_Number_a;
  }

  /* ZeroOrderHold Block: '<S6>/zoh'
   *
   * Regarding '<S6>/zoh':
   *   Eliminated since input and output rates are identical
   */

  /* Sum: '<S2>/Sum' incorporates:
   *   Constant: '<S6>/Constant'
   */
  rtB.Sum_a = rtb_temp15 + rtP.Constant_a_Value;

  /* DSP Blockset Buffer/Unbuffer (sdsprebuff2) - '<S2>/Buffer' */
  {
    rtB.Buffer_a = rtB.Sum_a;
  }

  /* S-Function Block: <S2>/Reshape */
  rtb_Reshape_a = rtB.Buffer_a;

  /* DSP Blockset Delay (sdspdly2) - '<S1>/Integer Delay' */

  {
    int_T ti = rtDWork.Integer_Delay_BUFF_OFFSET;

    memcpy(&rtb_temp15, ((byte_T *) &rtDWork.Integer_Delay_BUFF[0] +
      (ti*sizeof(real_T))), sizeof(real_T));
  }

  /* DiscretePulseGenerator: '<Root>/Pulse Generator' */
  rtB.Pulse_Generator =
    (rtDWork.Pulse_Generator_IWORK.ClockTicksCounter < rtP.Pulse_Generator_Duty
    &&
    rtDWork.Pulse_Generator_IWORK.ClockTicksCounter >= 0) ?
   rtP.Pulse_Generator_Amp :
    0.0;
  if (rtDWork.Pulse_Generator_IWORK.ClockTicksCounter >=
   rtP.Pulse_Generator_Period-1) {
    rtDWork.Pulse_Generator_IWORK.ClockTicksCounter = 0;
  } else {
    (rtDWork.Pulse_Generator_IWORK.ClockTicksCounter)++;
  }

  /* DSP Blockset Filter Implementation (sdspfilter) - '<S5>/Direct-Form II Transpose Filter' */
  /* Filter algorithm: IIR Direct-Form II Transpose (double precision floating-point) */
  /* Complexities: input - real, num coeffs - real, den coeffs - real */
  /* Implementing filter algorithm */
  MWDSP_IIR_DF2T_DD(&rtB.Pulse_Generator, &rtB.Direct_Form_II_Tran,
   &rtDWork.Direct_Form_II_Tran_FILT_STATES[0], 101, 1, 1,
   &rtP.Direct_Form_II_Tran_RTP1COEFF[0], 100,
   &rtP.Direct_Form_II_Tran_RTP2COEFF, 0, 1);

  /* RealImagToComplex: '<S1>/Join' */
  rtb_Join.re = rtb_temp15;
  rtb_Join.im = rtB.Direct_Form_II_Tran;

  /* ComplexToRealImag: '<Root>/Complex to Real-Imag' */
  rtb_Complex_to_Real_Imag_o1 = rtb_Join.re;
  rtb_Complex_to_Real_Imag_o2 = rtb_Join.im;

  /* RandomNumber: '<S3>/Random Number' */
  rtB.Random_Number_b = rtDWork.Random_Number_b_RWORK.NextOutput;

  /* DiscreteStateSpace: '<S11>/Discrete State-Space' */
  {
    rtb_temp15 = rtP.Discrete_State_Space_b_D*rtB.Random_Number_b;
  }

  /* ZeroOrderHold Block: '<S10>/zoh'
   *
   * Regarding '<S10>/zoh':
   *   Eliminated since input and output rates are identical
   */

  /* Sum: '<S3>/Sum' incorporates:
   *   Constant: '<S10>/Constant'
   */
  rtB.Sum_b = rtb_temp15 + rtP.Constant_b_Value;

  /* DSP Blockset Buffer/Unbuffer (sdsprebuff2) - '<S3>/Buffer' */
  {
    rtB.Buffer_b = rtB.Sum_b;
  }

  /* S-Function Block: <S3>/Reshape */
  rtb_Reshape_b = rtB.Buffer_b;

  /* Sum: '<Root>/Sum' incorporates:
   *   Product: '<Root>/Product1'
   *   Product: '<Root>/Product2'
   */
  rtb_temp15 = (rtb_Reshape_a * rtb_Complex_to_Real_Imag_o1)
    + (rtb_Complex_to_Real_Imag_o2 * rtb_Reshape_b);

  /* ToWorkspace: '<Root>/To Workspace' */

  rt_UpdateStructLogVar(rtDWork.To_Workspace_PWORK.LoggedData, NULL,
   &rtb_temp15);

  /* ToWorkspace: '<Root>/To Workspace1' */

  rt_UpdateStructLogVar(rtDWork.To_Workspace1_PWORK.LoggedData, NULL,
   &rtb_Reshape_b);
}

/* Update for root system: '<Root>' */
void MdlUpdate(int_T tid)
{

  /* tid is required for a uniform function interface. This system
   * is single rate, and in this case, tid is not accessed. */
  UNUSED_PARAMETER(tid);

  /* RandomNumber Block: <S2>/Random Number */
  rtDWork.Random_Number_a_RWORK.NextOutput = rt_NormalRand((uint_T
    *)&rtDWork.Random_Number_a_IWORK.RandSeed)*rtP.Random_Number_a_StdDev+rtP.Random_Number_a_Mean;

  /* DSP Blockset Delay (sdspdly2) - '<S1>/Integer Delay' */
  {
    const int_T bytesPerElem = sizeof(real_T);
    int_T bufferStart;

    /* Scalar input */
    bufferStart = rtDWork.Integer_Delay_BUFF_OFFSET;
    memcpy(((byte_T *) &rtDWork.Integer_Delay_BUFF[0]) +
     (bufferStart*bytesPerElem), &rtB.Pulse_Generator, bytesPerElem);
    rtDWork.Integer_Delay_BUFF_OFFSET += 1;
    while (rtDWork.Integer_Delay_BUFF_OFFSET >= rtP.Integer_Delay_Delays)
    rtDWork.Integer_Delay_BUFF_OFFSET -= rtP.Integer_Delay_Delays;
  }

  /* RandomNumber Block: <S3>/Random Number */
  rtDWork.Random_Number_b_RWORK.NextOutput = rt_NormalRand((uint_T
    *)&rtDWork.Random_Number_b_IWORK.RandSeed)*rtP.Random_Number_b_StdDev+rtP.Random_Number_b_Mean;
}

/* Terminate for root system: '<Root>' */
void MdlTerminate(void)
{
  if(rtM_fadingchannelconstructed != NULL) {
  }
}

/* Function to initialize sizes */
void MdlInitializeSizes(void)
{
  rtM_fadingchannelconstructed->Sizes.numContStates = (0); /* Number of continuous states */
  rtM_fadingchannelconstructed->Sizes.numY = (0); /* Number of model outputs */
  rtM_fadingchannelconstructed->Sizes.numU = (0); /* Number of model inputs */
  rtM_fadingchannelconstructed->Sizes.sysDirFeedThru = (0); /* The model is not direct feedthrough */
  rtM_fadingchannelconstructed->Sizes.numSampTimes = (1); /* Number of sample times */
  rtM_fadingchannelconstructed->Sizes.numBlocks = (22); /* Number of blocks */
  rtM_fadingchannelconstructed->Sizes.numBlockIO = (8); /* Number of block outputs */
  rtM_fadingchannelconstructed->Sizes.numBlockPrms = (124); /* Sum of parameter "widths" */
}

/* Function to initialize sample times */
void MdlInitializeSampleTimes(void)
{
  /* task periods */
  rtM_fadingchannelconstructed->Timing.sampleTimes[0] = (0.0002);

  /* task offsets */
  rtM_fadingchannelconstructed->Timing.offsetTimes[0] = (0.0);
}

/* Function to register the model */
rtModel_fadingchannelconstructed *fadingchannelconstructed(void)
{
  (void)memset((char *)rtM_fadingchannelconstructed, 0,
   sizeof(rtModel_fadingchannelconstructed));

  {
    /* Setup solver object */
    static RTWSolverInfo rt_SolverInfo;
    rtM_fadingchannelconstructed->solverInfo = (&rt_SolverInfo);

    rtsiSetSimTimeStepPtr(rtM_fadingchannelconstructed->solverInfo,
     &rtM_fadingchannelconstructed->Timing.simTimeStep);
    rtsiSetTPtr(rtM_fadingchannelconstructed->solverInfo,
     &rtmGetTPtr(rtM_fadingchannelconstructed));
    rtsiSetStepSizePtr(rtM_fadingchannelconstructed->solverInfo,
     &rtM_fadingchannelconstructed->Timing.stepSize);
    rtsiSetdXPtr(rtM_fadingchannelconstructed->solverInfo,
     &rtM_fadingchannelconstructed->ModelData.derivs);
    rtsiSetContStatesPtr(rtM_fadingchannelconstructed->solverInfo,
     &rtM_fadingchannelconstructed->ModelData.contStates);
    rtsiSetNumContStatesPtr(rtM_fadingchannelconstructed->solverInfo,
     &rtM_fadingchannelconstructed->Sizes.numContStates);
    rtsiSetErrorStatusPtr(rtM_fadingchannelconstructed->solverInfo,
     &rtmGetErrorStatus(rtM_fadingchannelconstructed));

    rtsiSetRTModelPtr(rtM_fadingchannelconstructed->solverInfo,
     rtM_fadingchannelconstructed);
  }

  /* timing info */
  {
    static time_T mdlPeriod[NSAMPLE_TIMES];
    static time_T mdlOffset[NSAMPLE_TIMES];
    static time_T mdlTaskTimes[NSAMPLE_TIMES];
    static int_T mdlTsMap[NSAMPLE_TIMES];
    static int_T mdlSampleHits[NSAMPLE_TIMES];

    {
      int_T i;

      for(i = 0; i < NSAMPLE_TIMES; i++) {
        mdlPeriod[i] = 0.0;
        mdlOffset[i] = 0.0;
        mdlTaskTimes[i] = 0.0;
      }
    }
    (void)memset((char_T *)&mdlTsMap[0], 0, 1 * sizeof(int_T));
    (void)memset((char_T *)&mdlSampleHits[0], 0, 1 * sizeof(int_T));

    rtM_fadingchannelconstructed->Timing.sampleTimes = (&mdlPeriod[0]);
    rtM_fadingchannelconstructed->Timing.offsetTimes = (&mdlOffset[0]);
    rtM_fadingchannelconstructed->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    rtmSetTPtr(rtM_fadingchannelconstructed, &mdlTaskTimes[0]);
    rtM_fadingchannelconstructed->Timing.sampleHits = (&mdlSampleHits[0]);
  }
  rtsiSetSolverMode(rtM_fadingchannelconstructed->solverInfo,
   SOLVER_MODE_SINGLETASKING);

  /*
   * initialize model vectors and cache them in SimStruct
   */

  /* block I/O */
  {
    void *b = (void *) &rtB;
    rtM_fadingchannelconstructed->ModelData.blockIO = (b);

    {
      int_T i;

      b =&rtB.Random_Number_a;
      for (i = 0; i < 8; i++) {
        ((real_T*)b)[i] = 0.0;
      }
    }
  }

  /* parameters */
  rtM_fadingchannelconstructed->ModelData.defaultParam = ((real_T *) &rtP);

  /* data type work */
  {
    void *dwork = (void *) &rtDWork;
    rtM_fadingchannelconstructed->Work.dwork = (dwork);
    (void)memset((char_T *) dwork, 0, sizeof(D_Work));
    {
      int_T i;
      real_T *dwork_ptr = (real_T *) &rtDWork.Integer_Delay_BUFF[0];

      for (i = 0; i < 154; i++) {
        dwork_ptr[i] = 0.0;
      }
    }
  }

  /* Model specific registration */

  rtM_fadingchannelconstructed->modelName = ("fadingchannelconstructed");
  rtM_fadingchannelconstructed->path = ("fadingchannelconstructed");

  rtmSetTStart(rtM_fadingchannelconstructed, 0.0);
  rtM_fadingchannelconstructed->Timing.tFinal = (10.0);
  rtM_fadingchannelconstructed->Timing.stepSize = (0.0002);
  rtsiSetFixedStepSize(rtM_fadingchannelconstructed->solverInfo, 0.0002);
  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;

    rtM_fadingchannelconstructed->rtwLogInfo = (&rt_DataLoggingInfo);

    rtliSetLogFormat(rtM_fadingchannelconstructed->rtwLogInfo, 0);

    rtliSetLogMaxRows(rtM_fadingchannelconstructed->rtwLogInfo, 1000);

    rtliSetLogDecimation(rtM_fadingchannelconstructed->rtwLogInfo, 1);

    rtliSetLogVarNameModifier(rtM_fadingchannelconstructed->rtwLogInfo, "none");

    rtliSetLogT(rtM_fadingchannelconstructed->rtwLogInfo, "tout");

    rtliSetLogX(rtM_fadingchannelconstructed->rtwLogInfo, "");

    rtliSetLogXFinal(rtM_fadingchannelconstructed->rtwLogInfo, "");

    rtliSetLogXSignalInfo(rtM_fadingchannelconstructed->rtwLogInfo, NULL);

    rtliSetLogXSignalPtrs(rtM_fadingchannelconstructed->rtwLogInfo, NULL);

    rtliSetLogY(rtM_fadingchannelconstructed->rtwLogInfo, "");

    rtliSetLogYSignalInfo(rtM_fadingchannelconstructed->rtwLogInfo, NULL);

    rtliSetLogYSignalPtrs(rtM_fadingchannelconstructed->rtwLogInfo, NULL);
  }

  rtM_fadingchannelconstructed->Sizes.checksums[0] = (4095649789U);
  rtM_fadingchannelconstructed->Sizes.checksums[1] = (2440085475U);
  rtM_fadingchannelconstructed->Sizes.checksums[2] = (3216992539U);
  rtM_fadingchannelconstructed->Sizes.checksums[3] = (240693362U);

  return rtM_fadingchannelconstructed;
}

